/* Problem URL: https://codeforces.com/contest/2132/problem/E */

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

template <class T, class comp = less<>>
using ordered_set = tree<T, null_type , comp , rb_tree_tag , tree_order_statistics_node_update>;

#define V vector

#define rmin(a, b) a = min(a, b)
#define rmax(a, b) a = max(a, b)

#define rep(i, lim) for (int i = 0; i < (lim); i++)
#define nrep(i, s, lim) for (int i = s; i < (lim); i++)

#define repv(i, v) for (auto &i : (v))
#define fillv(v) for (auto &itr_ : (v)) { cin >> itr_; }
#define sortv(v) sort(v.begin(), v.end())
#define all(v) (v).begin(), (v).end()

using vi = vector<int>;
using vvi = vector<vi>;
using vvvi = vector<vvi>;
using vvvvi = vector<vvvi>;

using ll = long long;

using vl = vector<ll>;
using vvl = vector<vl>;
using vvvl = vector<vvl>;
using vvvvl = vector<vvvl>;

template<class v>
auto operator<<(ostream &os, const vector<v> &vec)->ostream& {
    os << vec[0];
    for (size_t i = 1; i < vec.size(); i++) {
        os << ' ' << vec[i];
    }
    os << '\n';
    return os;
}

template<class v>
auto operator>>(istream &is, vector<v> &vec)->istream& {
    for (auto &i : vec) {
        is >> i;
    }
    return is;
}

template<class v>
auto operator<<(ostream &os, const vector<vector<v>> &vec)->ostream& {
    for (auto &i : vec) {
        os << i[0];
        for (size_t j = 1; j < i.size(); j++) {
            os << ' ' << i[j];
        }
        os << '\n';
    }
    return os;
}

template<class v>
auto operator>>(istream  &is, vector<vector<v>> &vec)->istream& {
    for (auto &i : vec) {
        for (auto &j : i) {
            is >> j;
        }
    }
    return is;
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int t;
    cin >> t;
    while (t--) {
        int n, m, q;
        cin >> n >> m >> q;

        vl af(n);
        vl bf(m);

        cin >> af >> bf;

        vl a(n + 1);
        vl b(m + 1);

        sort(all(af), greater<>());
        sort(all(bf), greater<>());

        rep(i, n) {
            a[i + 1] = a[i] + af[i];
        }

        rep(i, m) {
            b[i + 1] = b[i] + bf[i];
        }

        while (q--) {
            int x, y, z;
            cin >> x >> y >> z;

            ll ans = 0;
            ll low = 0;
            ll high = min(x, z);

            while ((high - low) >= 3) {
                ll third = (high - low) / 3;
                ll mid1 = low + third;
                ll mid2 = high - third;

                ll ans1 = a[mid1] + b[max(min(z - mid1, (ll)y), 0LL)];
                ll ans2 = a[mid2] + b[max(min(z - mid2, (ll)y), 0LL)];

                ans = max({ans, ans1, ans2});

                if (ans1 > ans2) {
                    high = mid2 - 1;
                    continue;
                }

                if (ans2 > ans1) {
                    low = mid1 + 1;
                    continue;
                }

                low = mid1 + 1;
                high = mid2 - 1;
            }

            nrep(i, low, high + 1) {
                rmax(ans, a[i] + b[max(min(z - (ll)i, (ll)y), 0LL)]);
            }

            cout << ans << '\n';
        }
    }
}
